/*
 * CONTRAT DE LICENCE DE LOGICIEL LIBRE CeCILL-B
 * https://cecill.info/licences/Licence_CeCILL-B_V1-fr.html
 */
package fr.unistra.sil.erp.back.db;

import fr.unistra.sil.erp.back.api.model.Item;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author BEAUVAIS ANTOINE <antoine.beauvais@etu.unistra.fr>
 */
public class DatabaseSQLiteImpl implements DatabaseInterface {
    
    private static final String CONNECTION_URL = "jdbc:sqlite:dev.db";
    private static final String SQL_GETALLITEMS = 
            "SELECT ref, name, price, subscriberPrice, category FROM items";
    
    private Connection conn;
    
    public DatabaseSQLiteImpl()
    {
        try {
            conn = DriverManager.getConnection(CONNECTION_URL);
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseSQLiteImpl.class.getName()).log(
                    Level.SEVERE, "Failed to connect to SQLite file.", ex);
        }
    }
    
    private ResultSet query(String query)
    {
        Statement stmt;
        ResultSet rs;
        try {
            stmt = this.conn.createStatement();
            rs = stmt.executeQuery(SQL_GETALLITEMS);
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseSQLiteImpl.class.getName()).log(
                    Level.SEVERE, "Failed to run query: " + query, ex);
            return null;
        }
        
        return rs;
    }

    @Override
    public List<Item> getAllItems() {
        ResultSet rs = query(SQL_GETALLITEMS);
        if(rs == null)
            return null;
        
        List<Item> res = new ArrayList<>();
        try {
            while(rs.next())
            {
                Item item = new Item(rs.getInt("ref"), rs.getString("name"),
                                     rs.getBigDecimal("price"),
                                     rs.getBigDecimal("subscriberPrice"),
                                     rs.getInt("category"));
                res.add(item);
            }
        } catch (SQLException ex) {
            Logger.getLogger(DatabaseSQLiteImpl.class.getName()).log(
                    Level.SEVERE, null, ex);
            return null;
        }
        
        return res;
    }
    
}
